/* $Id: IGColor.cpp,v 1.1 2001/04/22 09:09:34 formella Exp $ */

/*
 *  Copyright (C) 2001, Dr. Arno Formella
 *                      Universidade de Vigo
 *                      Departamento de Informatica
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License
 *          http://www.gnu.ai.mit.edu/copyleft/gpl.html
 *  for more details.
 */

#include "IGColor.h"

double IGColor::Clamp(
  double v
) const {
  return(v>1.0?1.0:v<0.0?0.0:v);
}

IGColor::IGColor(
  double gray=0.0
) {
  red=green=blue=Clamp(gray);
}

IGColor::IGColor(
  double r,
  double g,
  double b
) :
  red(Clamp(r)),
  green(Clamp(g)),
  blue(Clamp(b))
{
}

IGColor::IGColor(
  const IGColor& C
) :
  red(C.red),
  green(C.green),
  blue(C.blue)
{
}

IGColor::~IGColor() {}

void IGColor::SetColor(
) const {
  glColor3d(red,green,blue);
}

IGColor& IGColor::operator=(
  const IGColor& C
) {
  if(this!=&C) {
    red  =C.red;
    green=C.green;
    blue =C.blue;
  }
  return(*this);
}

istream& operator>>(
  istream& in,
  IGColor& C
) {
  in >> C.red >> C.green >> C.blue;
  C.red  =C.Clamp(C.red);
  C.green=C.Clamp(C.green);
  C.blue =C.Clamp(C.blue);
  return(in);
}

ostream& operator<<(
  ostream& out,
  const IGColor& C
) {
  out << "Color: (" << C.red << "," << C.green << "," << C.blue << ")" << endl;
  return(out);
}

