/* $Id: IGPoint.cpp,v 1.1 2001/04/22 09:09:34 formella Exp $ */

/*
 *  Copyright (C) 2001, Dr. Arno Formella
 *                      Universidade de Vigo
 *                      Departamento de Informatica
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License
 *          http://www.gnu.ai.mit.edu/copyleft/gpl.html
 *  for more details.
 */

#include "IGPoint.h"
#include <GL/glut.h>

IGPoint::IGPoint(
) {
}

IGPoint::IGPoint(
  double x,
  double y,
  double z,
  double gray
) :
  d3_point(x,y,z),
  col(gray)
{
}

IGPoint::IGPoint(
  double x,
  double y,
  double z,
  double red,
  double green,
  double blue
) :
  d3_point(x,y,z),
  col(red,green,blue)
{
}

IGPoint::IGPoint(
  const IGPoint& P
) :
  d3_point(P),
  col(P.col)
{
}

IGPoint::~IGPoint(
) {
}

IGPoint& IGPoint::operator=(
  const IGPoint& P
) {
  if(this!=&P) {
    d3_point::operator=(P);
    col=P.col;
  }
  return(*this);
}

void IGPoint::Draw(
) const {
  col.SetColor();
  glVertex3d(xcoord(),ycoord(),zcoord());
}

istream& operator>>(
  istream& in,
  IGPoint& P
) {
  in >> (d3_point&)P >> P.col;
  return(in);
}

ostream& operator<<(
  ostream& out,
  const IGPoint& P
) {
  out << "Point: " << (d3_point)P << endl << P.col;
  return(out);
}

