/* $Id: IGPoint.h,v 1.1 2001/04/22 09:09:34 formella Exp $ */

/*
 *  Copyright (C) 2001, Dr. Arno Formella
 *                      Universidade de Vigo
 *                      Departamento de Informatica
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License
 *          http://www.gnu.ai.mit.edu/copyleft/gpl.html
 *  for more details.
 */

#ifndef IGPOINT_H
#define IGPOINT_H

#include <LEDA/d3_point.h>

#include "IGColor.h"

class IGPoint : public d3_point {
private:
  /// the color of the point
  IGColor col;
public:
  IGPoint();
  IGPoint(double x, double y, double z, double gray=0.0);
  IGPoint(double x, double y, double z, double red, double green, double blue);
  IGPoint(const IGPoint& P);
  ~IGPoint();
  IGPoint& operator=(const IGPoint& P);
  /// draws the point using OpenGL
  void Draw(void) const;
  /// reads a point from the input stream
  /// NOTE: is not the inverse of the operator<<
  friend istream& operator>>(istream& in, IGPoint& P);
  /// writes a point to the output stream
  /// NOTE: is not the inverse of the operator>>
  friend ostream& operator<<(ostream& out, const IGPoint& P);
};

#endif
