/* $Id: IGPolygon.cpp,v 1.1 2001/04/22 09:09:34 formella Exp $ */

/*
 *  Copyright (C) 2001, Dr. Arno Formella
 *                      Universidade de Vigo
 *                      Departamento de Informatica
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License
 *          http://www.gnu.ai.mit.edu/copyleft/gpl.html
 *  for more details.
 */

#include <assert.h>

#include "IGPolygon.h"

IGPolygon::IGPolygon(
) :
  okForOpenGL(false)
{
}

IGPolygon::IGPolygon(
  const IGPolygon& P
) :
  corners(P.corners),
  center(P.center),
  normal(P.normal),
  okForOpenGL(P.okForOpenGL)
{
}

IGPolygon::~IGPolygon(
) {
}

IGPolygon& IGPolygon::operator=(
  const IGPolygon& P
) {
  if(this!=&P) {
    corners    =P.corners;
    center     =P.center;
    normal     =P.normal;
    okForOpenGL=P.okForOpenGL;
  }
  return(*this);
}

void IGPolygon::CheckForOpenGL(
) {
  okForOpenGL=false;
  ComputeCenter();
  if(ComputeNormal()) {
    // TODO:
    okForOpenGL=true;
  }
}

void IGPolygon::ComputeCenter(
) {
  assert(!corners.empty());
  IGPoint  p;
  d3_point o;
  forall(p,corners) o=o+p.to_vector();
  center=d3_point(o.to_vector()*(1.0/corners.size()));
}

bool IGPolygon::ComputeNormal(
) {
  // TODO:
  return true;
}

void IGPolygon::Draw(
) const {
  glBegin(GL_POLYGON);
  IGPoint p;
  forall(p,corners) p.Draw();
  glEnd();
}

bool IGPolygon::IsSimpleAndConvex(
  const list<point>& L
) const {
  // TODO:
  return true;
}

istream& operator>>(
  istream& in,
  IGPolygon& P
) {
  int     n;
  IGPoint p;

  P.corners.clear();
  P.okForOpenGL=false;
  in >> n;
  assert(n>0);
  for(int i(0); i<n; i++) {
    in >> p;
    P.corners.append(p);
  }
  P.CheckForOpenGL();
  return(in);
}

ostream& operator<<(
  ostream& out,
  const IGPolygon& P
) {
  out << "Polygon: " << P.corners.size() << endl;
  out << "okForOpenGL: " << P.okForOpenGL << endl;
  out << "center: " << P.center << endl;
  out << "normal: " << P.normal << endl;
  IGPoint p;
  forall(p,P.corners) out << p;
  return(out);
}

